window.addEvent('domready', function(){

	$$('.queue, .at_url').each(function(attachmentLink) {
		attachmentLink.addEvent('click', function(event){
			event.stop();

			var downloadQueue = document.id('downloadqueue');
			var currentDocumentID = this.getAttribute('data-id');
			var currentDocumentCheckbox = document.id('docmancartselection-'+currentDocumentID);

			var queueURL = 'option=com_ajax&module=downloadqueue&method=queue&format=raw&id=';
			var clearURL = 'option=com_ajax&module=downloadqueue&method=clear&format=raw&id=';

			var myRequest = new Request({
				url: '',
				method: 'get',
				link: 'chain',
				evalScripts: true,
				onRequest: function(){
					//myElement.set('text', 'loading...');
				},
				onSuccess: function(responseText){

                    if (downloadQueue)
                    {
                        downloadQueue.set('html', responseText);
                        $$('.scrollbar').destroy();
                        applyEventsToCart();
                    }

					// Toggle the selected item:
					if (currentDocumentCheckbox.checked)
					{
						currentDocumentCheckbox.checked = false;

						var checkboxesForTable = attachmentLink.getParent('table').getElements('.docmancartselection');

						var areAllUnselected = true;
						checkboxesForTable.each(function(individualCheckbox) {
							if (individualCheckbox.checked)
							{
								areAllUnselected = false;
							}
						});

						if (areAllUnselected)
						{
							var checkallForTable = attachmentLink.getParent('table').getElement('.docmancartselectionall');
							checkallForTable.checked = false;
						}
					}
					else
					{
						currentDocumentCheckbox.checked = true;

						var checkboxesForTable = attachmentLink.getParent('table').getElements('.docmancartselection');

						var areAllSelected = true;
						checkboxesForTable.each(function(individualCheckbox) {
							if (individualCheckbox.checked === false)
							{
								areAllSelected = false;
							}
						});

						if (areAllSelected)
						{
							var checkallForTable = attachmentLink.getParent('table').getElement('.docmancartselectionall');
							checkallForTable.checked = true;
						}
					}
				},
				onFailure: function(){
					//myElement.set('text', 'Sorry, your request failed :(');
				}
			});

			/*
			downloadQueue.set('load', {
				method: 'get',
				link: 'chain',
				evalScripts: true,
				onRequest: function(){
				  //result.set('text', 'Loading...');
				},
				onSuccess: function(txt){
					$$('.scrollbar').destroy();
					applyEventsToCart();
				},
				// Our request will most likely succeed, but just in case, we'll add an
				// onFailure method which will let the user know what happened.
				onFailure: function(){
				  //result.set('text', 'The request failed.');
				}
			});
			*/

			// Depending on the state of the checkbox we have to do the opposite Request type:
			if (currentDocumentCheckbox.checked)
			{
				myRequest.send(clearURL + currentDocumentID + '&' + (new Date()).getTime());
			}
			else
			{
				myRequest.send(queueURL + currentDocumentID + '&' + (new Date()).getTime());
			}

		});
	});

	$$('.docmancartselectionall').each(function(selectedItemAll) {
		var downloadQueue = document.id('downloadqueue');

		var queueURL = 'option=com_ajax&module=downloadqueue&method=queueMultiple&format=raw&ids=';
		var clearURL = 'option=com_ajax&module=downloadqueue&method=clearMultiple&format=raw&ids=';

		selectedItemAll.addEvent('click', function(event) {
			event.stop();

			var checkboxesForTable = selectedItemAll.getParent('table').getElements('.docmancartselection');

			var ids = [];
			checkboxesForTable.each(function(individualCheckbox) {
				ids.push(individualCheckbox.value);
			});

			var idString = ids.join(',');

			var myRequest = new Request({
				url: '',
				method: 'get',
				link: 'chain',
				evalScripts: true,
				onRequest: function(){
					//myElement.set('text', 'loading...');
				},
				onSuccess: function(responseText){

                    if (downloadQueue)
                    {
					    downloadQueue.set('html', responseText);
					    $$('.scrollbar').destroy();
					    applyEventsToCart();
                    }

					// Toggle the selected item:
					if (selectedItemAll.checked)
					{
						selectedItemAll.checked = false;

						// Toggle all of the individual checkboxes:
						checkboxesForTable.each(function(individualCheckbox) {
							individualCheckbox.checked = false;
						});
					}
					else
					{
						selectedItemAll.checked = true;

						// Toggle all of the individual checkboxes:
						checkboxesForTable.each(function(individualCheckbox) {
							individualCheckbox.checked = true;
						});
					}
				},
				onFailure: function(){
					//myElement.set('text', 'Sorry, your request failed :(');
				}
			});

			if (this.checked)
			{
				myRequest.send(queueURL + idString + '&' + (new Date()).getTime());
			}
			else
			{
				myRequest.send(clearURL + idString + '&' + (new Date()).getTime());
			}
		});
	});

	$$('.docmancartselection').each(function(selectedItem) {
		selectedItem.addEvent('click', function(event){
			event.stop();
			var downloadQueue = document.id('downloadqueue');

			var queueURL = 'option=com_ajax&module=downloadqueue&method=queue&format=raw&id=';
			var clearURL = 'option=com_ajax&module=downloadqueue&method=clear&format=raw&id=';

			var myRequest = new Request({
				url: '',
				method: 'get',
				link: 'chain',
				evalScripts: true,
				onRequest: function(){
					//myElement.set('text', 'loading...');
				},
				onSuccess: function(responseText){

                    if (downloadQueue)
                    {
					    downloadQueue.set('html', responseText);
					    $$('.scrollbar').destroy();
					    applyEventsToCart();
                    }

					// Toggle the selected item:
					if (selectedItem.checked)
					{
						selectedItem.checked = false;

						var checkboxesForTable = selectedItem.getParent('table').getElements('.docmancartselection');

						var areAllUnselected = true;
						checkboxesForTable.each(function(individualCheckbox) {
							if (individualCheckbox.checked)
							{
								areAllUnselected = false;
							}
						});

						if (areAllUnselected)
						{
							var checkallForTable = selectedItem.getParent('table').getElement('.docmancartselectionall');
							checkallForTable.checked = false;
						}
					}
					else
					{
						selectedItem.checked = true;

						var checkboxesForTable = selectedItem.getParent('table').getElements('.docmancartselection');

						var areAllSelected = true;
						checkboxesForTable.each(function(individualCheckbox) {
							if (individualCheckbox.checked === false)
							{
								areAllSelected = false;
							}
						});

						if (areAllSelected)
						{
							var checkallForTable = selectedItem.getParent('table').getElement('.docmancartselectionall');
							checkallForTable.checked = true;
						}
					}
				},
				onFailure: function(){
					//myElement.set('text', 'Sorry, your request failed :(');
				}
			});

			if (this.checked)
			{
				myRequest.send(queueURL + this.value + '&' + (new Date()).getTime());
			}
			else
			{
				myRequest.send(clearURL + this.value + '&' + (new Date()).getTime());
			}

		});
	});

	var applyEventsToCart = function() {
		$$('.downloadqueue-download-button').each(function(downloadLink) {
			downloadLink.addEvent('click', function(event){
				event.stop();

				var originalText = this.get('text');
				//We can use one Request object many times.
				var req = new Request({
					url: this.href,

					onRequest: function(){
						if (docmanCartGeneratingString)
						{
							downloadLink.set('text', docmanCartGeneratingString);
						}
						else
						{
							downloadLink.set('text', 'Generating ZIP...');
						}
					},
					onSuccess: function(txt){

					  //result.set('text', txt);
					  //window.location.reload();
					  var download = downloadLink.get('rel');
					  downloadLink.set('text', originalText);
					  //window.location = download;

                      function randomString(length, chars) {
                        var result = '';
                        for (var i = length; i > 0; --i) result += chars[Math.round(Math.random() * (chars.length - 1))];
                        return result;
                      }

                      //var downloadIframeId = 'downloadqueue_' + randomString(16, '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ');

                      var downloadIframe = new IFrame({
                         src: download,
                         styles: {
                             display: 'none'
                         }
                      });

                      downloadIframe.inject(document.body);
                      //$('downloadIframeId').location = download;

                      $$('.downloadqueue-clear-button').each(function(removalLink) {
                        removalLink.fireEvent('click', {
                                stop: function(){}
                            },
                            1000
                        );
                      });

					},
					// Our request will most likely succeed, but just in case, we'll add an
					// onFailure method which will let the user know what happened.
					onFailure: function(){
					  //result.set('text', 'The request failed.');
					}
				});

				req.send({data: {
					// return this as return html
					html: 'The request was successful!'
				}});

			});
		});

		$$('.downloadqueue-item-clear-button, .downloadqueue-clear-button').each(function(removalLink) {
			removalLink.addEvent('click', function(event){
				event.stop();

				var downloadQueue = document.id('downloadqueue');
				var currentDocumentID = this.getAttribute('data-id');
				var currentDocumentCheckbox = document.id('docmancartselection-'+currentDocumentID);

				var clearURL = 'option=com_ajax&module=downloadqueue&method=clear&format=raw&id=';

				var myRequest = new Request({
					url: '',
					method: 'get',
					link: 'chain',
					evalScripts: true,
					onRequest: function(){
						//myElement.set('text', 'loading...');
					},
					onSuccess: function(responseText){
						downloadQueue.set('html', responseText);

						// Clear the selection(s) in the list:
						if (currentDocumentCheckbox)
						{
							currentDocumentCheckbox.checked = false;

							var checkboxesForTable = currentDocumentCheckbox.getParent('table').getElements('.docmancartselection');

							var areAllUnselected = true;
							checkboxesForTable.each(function(individualCheckbox) {
								if (individualCheckbox.checked)
								{
									areAllUnselected = false;
								}
							});

							if (areAllUnselected)
							{
								var checkallForTable = currentDocumentCheckbox.getParent('table').getElement('.docmancartselectionall');
								checkallForTable.checked = false;
							}
						}
						else
						{
							$$('.docmancartselection').each(function(selectedCheckbox) {
								if (selectedCheckbox.checked)
								{
									selectedCheckbox.checked = false;
								}
							});

							$$('.docmancartselectionall').each(function(selectedCheckbox) {
								if (selectedCheckbox.checked)
								{
									selectedCheckbox.checked = false;
								}
							});
						}

						$$('.scrollbar').destroy();
						applyEventsToCart();
					},
					onFailure: function(){
						//myElement.set('text', 'Sorry, your request failed :(');
					}
				});

				// Clear the selection in the list:
				if (currentDocumentCheckbox)
				{
					myRequest.send(clearURL + currentDocumentID + '&' + (new Date()).getTime());
				}
				else
				{
					var clearURL = 'option=com_ajax&module=downloadqueue&method=clear&format=raw';
					myRequest.send(clearURL + '&' + (new Date()).getTime());

				}
			});
		});

		var DownloadCartScroll = new Scrollable($$('.downloadqueue-list'));
	};

	// Call function initially:
	applyEventsToCart();
});